<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>Crypto Driver HMAC Register Level Functions</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<table width=100%>
<tr>
  <td bgcolor="black" width="1"><a href="http://www.ti.com"><img border=0 src="../../tilogo.gif"></a></td>
  <td bgcolor="red"><img src="../../titagline.gif"></td>
</tr>
</table>
<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">Crypto Driver HMAC Register Level Functions<div class="ingroups"><a class="el" href="group___c_r_y_p_t_o___d_r_i_v_e_r.html">Crypto Driver</a> &raquo; <a class="el" href="group___c_r_y_p_t_o___i_n_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html">Crypto Driver Internal Functions</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>The section has a list of all the HMAC functions used internally by the driver.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:gaa8ee6b3d0b1ebac067c5279f1c7df08d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n.html#gaa8ee6b3d0b1ebac067c5279f1c7df08d">HMAC_init</a> (<a class="el" href="reg__dthe_8h.html#ab9c267af115a7b2bf09e212c1489e290">DTHERegs</a> *dtheBaseAddress, <a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *hmacBaseAddress)</td></tr>
<tr class="separator:gaa8ee6b3d0b1ebac067c5279f1c7df08d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga03e3ffdc920a37b8017b5c563081f0b9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n.html#ga03e3ffdc920a37b8017b5c563081f0b9">HMAC_setConfig</a> (<a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *hmacBaseAddress, uint32_t cryptoMode, uint8_t useAlgoConstant, uint8_t closeHash, uint8_t useHMACKey, uint8_t HMACOuterHash)</td></tr>
<tr class="separator:ga03e3ffdc920a37b8017b5c563081f0b9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga95f00349641531e14ca514d874f84e5b"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n.html#ga95f00349641531e14ca514d874f84e5b">HMAC_isReady</a> (const <a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *hmacBaseAddress, uint32_t flag)</td></tr>
<tr class="separator:ga95f00349641531e14ca514d874f84e5b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga9762ccd0d044f11324efa3e67991562b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n.html#ga9762ccd0d044f11324efa3e67991562b">HMAC_setDataLength</a> (<a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *hmacBaseAddress, uint32_t dataLength)</td></tr>
<tr class="separator:ga9762ccd0d044f11324efa3e67991562b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga041725b050d79988ecf9b8ddb568f38d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n.html#ga041725b050d79988ecf9b8ddb568f38d">HMAC_writeData</a> (<a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *hmacBaseAddress, const uint8_t *ptrData)</td></tr>
<tr class="separator:ga041725b050d79988ecf9b8ddb568f38d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gac995432668ebf089a9c6370d3cfe3f04"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n.html#gac995432668ebf089a9c6370d3cfe3f04">HMAC_getDigestSize</a> (uint32_t config)</td></tr>
<tr class="separator:gac995432668ebf089a9c6370d3cfe3f04"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga8ca2d4d5a4dc187e52a9ac6c505c955c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n.html#ga8ca2d4d5a4dc187e52a9ac6c505c955c">HMAC_readResult</a> (<a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *hmacBaseAddress, uint8_t *ptrData)</td></tr>
<tr class="separator:ga8ca2d4d5a4dc187e52a9ac6c505c955c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaa073fbb371abcaac9ee0f1221e0cc2df"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n.html#gaa073fbb371abcaac9ee0f1221e0cc2df">HMAC_writeResult</a> (<a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *hmacBaseAddress, uint8_t *ptrData)</td></tr>
<tr class="separator:gaa073fbb371abcaac9ee0f1221e0cc2df"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga80e49be08f069531c854012de3aea1bd"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n.html#ga80e49be08f069531c854012de3aea1bd">HMAC_readDigestCount</a> (<a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *hmacBaseAddress)</td></tr>
<tr class="separator:ga80e49be08f069531c854012de3aea1bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga0782e35e1567eb466f3973a628796e9d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n.html#ga0782e35e1567eb466f3973a628796e9d">HMAC_writeDigestCount</a> (<a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *hmacBaseAddress, uint32_t digestCount)</td></tr>
<tr class="separator:ga0782e35e1567eb466f3973a628796e9d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf2333bc6fe289e21a0c2ea29f1e07b25"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n.html#gaf2333bc6fe289e21a0c2ea29f1e07b25">HMAC_setHMACKey</a> (<a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *hmacBaseAddress, const uint8_t *ptrKey)</td></tr>
<tr class="separator:gaf2333bc6fe289e21a0c2ea29f1e07b25"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga55c317213fd84152e3a2b8f5d6bc4e5c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n.html#ga55c317213fd84152e3a2b8f5d6bc4e5c">HMAC_setHMACPPKey</a> (<a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *hmacBaseAddress, const uint8_t *ptrKey)</td></tr>
<tr class="separator:ga55c317213fd84152e3a2b8f5d6bc4e5c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga95d15336c35306dd37228c2cc33e9183"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n.html#ga95d15336c35306dd37228c2cc33e9183">HMAC_enableInterrupt</a> (<a class="el" href="reg__dthe_8h.html#ab9c267af115a7b2bf09e212c1489e290">DTHERegs</a> *dtheBaseAddress, <a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *hmacBaseAddress, uint32_t intFlags)</td></tr>
<tr class="separator:ga95d15336c35306dd37228c2cc33e9183"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga46e162a7ea45a5c9c8bf0ed7b7010e51"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n.html#ga46e162a7ea45a5c9c8bf0ed7b7010e51">HMAC_disableInterrupt</a> (<a class="el" href="reg__dthe_8h.html#ab9c267af115a7b2bf09e212c1489e290">DTHERegs</a> *dtheBaseAddress, <a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *hmacBaseAddress, uint32_t intFlags)</td></tr>
<tr class="separator:ga46e162a7ea45a5c9c8bf0ed7b7010e51"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga8f28cf23064bc2e61afe9d6a2699cd89"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n.html#ga8f28cf23064bc2e61afe9d6a2699cd89">HMAC_clearInterrupt</a> (<a class="el" href="reg__dthe_8h.html#ab9c267af115a7b2bf09e212c1489e290">DTHERegs</a> *dtheBaseAddress, uint32_t intFlags)</td></tr>
<tr class="separator:ga8f28cf23064bc2e61afe9d6a2699cd89"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga16e39db923726e0029cfa63fc6cfe244"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n.html#ga16e39db923726e0029cfa63fc6cfe244">HMAC_getInterruptStatus</a> (<a class="el" href="reg__dthe_8h.html#ab9c267af115a7b2bf09e212c1489e290">DTHERegs</a> *dtheBaseAddress, <a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *hmacBaseAddress, uint8_t masked)</td></tr>
<tr class="separator:ga16e39db923726e0029cfa63fc6cfe244"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>The section has a list of all the HMAC functions used internally by the driver. </p>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="ga8f28cf23064bc2e61afe9d6a2699cd89"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HMAC_clearInterrupt </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__dthe_8h.html#ab9c267af115a7b2bf09e212c1489e290">DTHERegs</a> *&#160;</td>
          <td class="paramname"><em>dtheBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>intFlags</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 The function clears the HMAC interrupts.</p>
<dl class="section note"><dt>Note</dt><dd>The DMA done interrupts are the only interrupts that can be cleared using this function. The remaining interrupts can be disabled using the <a class="el" href="group___c_r_y_p_t_o___h_m_a_c___r_l___f_u_n_c_t_i_o_n.html#ga46e162a7ea45a5c9c8bf0ed7b7010e51">HMAC_disableInterrupt()</a> function.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">dtheBaseAddress</td><td>Base address of DTHE module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">intFlags</td><td>Bit mask for the following interrupt sources. HMAC_INT_DMA_CONTEXT_IN - Context DMA done interrupt HMAC_INT_DMA_CONTEXT_OUT - Authentication tag (and IV) DMA done interrupt HMAC_INT_DMA_DATA_IN - Data input DMA done interrupt HMAC_INT_DMA_DATA_OUT - Data output DMA done interrupt</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Not</td><td>applicable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga46e162a7ea45a5c9c8bf0ed7b7010e51"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HMAC_disableInterrupt </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__dthe_8h.html#ab9c267af115a7b2bf09e212c1489e290">DTHERegs</a> *&#160;</td>
          <td class="paramname"><em>dtheBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *&#160;</td>
          <td class="paramname"><em>hmacBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>intFlags</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 The function disables the HMAC interrupts.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">dtheBaseAddress</td><td>Base address of DTHE module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">hmacBaseAddress</td><td>Base address of HMAC module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">intFlags</td><td>Bit mask for the following interrupt sources. HMAC_INT_CONTEXT_READY - Context input registers are ready. HMAC_INT_PARTHASH_READY - Context output registers are ready after a context switch. HMAC_INT_INPUT_READY - Data FIFO is ready to receive data. HMAC_INT_OUTPUT_READY - Context output registers are ready.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Not</td><td>applicable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga95d15336c35306dd37228c2cc33e9183"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HMAC_enableInterrupt </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__dthe_8h.html#ab9c267af115a7b2bf09e212c1489e290">DTHERegs</a> *&#160;</td>
          <td class="paramname"><em>dtheBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *&#160;</td>
          <td class="paramname"><em>hmacBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>intFlags</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 The function enables the HMAC interrupts.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">dtheBaseAddress</td><td>Base address of DTHE module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">hmacBaseAddress</td><td>Base address of HMAC module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">intFlags</td><td>Bit mask for the following interrupt sources. HMAC_INT_CONTEXT_READY - Context input registers are ready. HMAC_INT_PARTHASH_READY - Context output registers are ready after a context switch. HMAC_INT_INPUT_READY - Data FIFO is ready to receive data. HMAC_INT_OUTPUT_READY - Context output registers are ready.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Not</td><td>applicable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="gac995432668ebf089a9c6370d3cfe3f04"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t HMAC_getDigestSize </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>config</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 This function returns the number of bytes of digest for the specified hash algorithm.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">config</td><td>Bit values for the algorithm as specified in the mode register.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Number</td><td>of bytes in the digest. </td></tr>
  </table>
  </dd>
</dl>
<p>Return without reading a result since the hardware appears to be misconfigured.</p>

</div>
</div>
<a class="anchor" id="ga16e39db923726e0029cfa63fc6cfe244"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t HMAC_getInterruptStatus </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__dthe_8h.html#ab9c267af115a7b2bf09e212c1489e290">DTHERegs</a> *&#160;</td>
          <td class="paramname"><em>dtheBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *&#160;</td>
          <td class="paramname"><em>hmacBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>masked</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 The function returns the interrupt status.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">dtheBaseAddress</td><td>Base address of DTHE module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">hmacBaseAddress</td><td>Base address of SHA module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">masked</td><td>0 - Raw interrupt status is read. 1 - Masked interrupt status is read.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Bit</td><td>mask for the following interrupt sources. HMAC_INT_CONTEXT_READY - Context input registers are ready. HMAC_INT_PARTHASH_READY - Context output registers are ready after a context switch. HMAC_INT_INPUT_READY - Data FIFO is ready to receive data. HMAC_INT_OUTPUT_READY - Context output registers are ready. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="gaa8ee6b3d0b1ebac067c5279f1c7df08d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HMAC_init </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__dthe_8h.html#ab9c267af115a7b2bf09e212c1489e290">DTHERegs</a> *&#160;</td>
          <td class="paramname"><em>dtheBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *&#160;</td>
          <td class="paramname"><em>hmacBaseAddress</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 The function Initialize the HMAC module.</p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Not</td><td>applicable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga95f00349641531e14ca514d874f84e5b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t HMAC_isReady </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *&#160;</td>
          <td class="paramname"><em>hmacBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>flag</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 The function checks if the interrupt register is ready for operation indicated by flag.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">hmacBaseAddress</td><td>Base address of HMAC module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">flag</td><td>Indicates the bit positions to check if ready.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">0</td><td>- Not ready for access &gt;0 - Ready for access </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga80e49be08f069531c854012de3aea1bd"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t HMAC_readDigestCount </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *&#160;</td>
          <td class="paramname"><em>hmacBaseAddress</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 This function reads the byte count of the current hashing operation.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">hmacBaseAddress</td><td>Base address of HMAC module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">ptrDigestCount</td><td>Pointer to a location to return the digest count.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Digest</td><td>Count in bytes. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga8ca2d4d5a4dc187e52a9ac6c505c955c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HMAC_readResult </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *&#160;</td>
          <td class="paramname"><em>hmacBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>ptrData</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 This function reads the result of a hash operation.The length of hash or digest depends on the algorithm used for hashing.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">hmacBaseAddress</td><td>Base address of HMAC module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ptrData</td><td>Pointer to a data buffer where the data is stored.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Not</td><td>applicable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga03e3ffdc920a37b8017b5c563081f0b9"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HMAC_setConfig </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *&#160;</td>
          <td class="paramname"><em>hmacBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>cryptoMode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>useAlgoConstant</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>closeHash</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>useHMACKey</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>HMACOuterHash</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 The function configures the HMAC module with input configuration parameters.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">hmacBaseAddress</td><td>Base address of HMAC module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">cryptoMode</td><td>Specifies the Hash algorithm. Valid values are: HMAC_ALGO_MD5 HMAC_ALGO_SHA1 HMAC_ALGO_SHA224 HMAC_ALGO_SHA256</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">useAlgoConstant</td><td>If set to 1, The initial digest register will be overwritten with the algorithm constants for the selected algorithm </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">closeHash</td><td>Specifies if the hash is closed or not. 1 - hash/HMAC will be 'closed' at the end of the block and appropriate padding is added. 0 - hash/HMAC will not be closed and can be continued later. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">useHMACKey</td><td>The hash core will perform HMAC key processing on the 512 bit HMAC key loaded in the digest registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">HMACOuterHash</td><td>1 - The HMAC Outer Hash is performed on the hash digest when the inner hash hash finished.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Not</td><td>applicable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga9762ccd0d044f11324efa3e67991562b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HMAC_setDataLength </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *&#160;</td>
          <td class="paramname"><em>hmacBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>dataLength</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 The function configures the data length of the the block to be processed.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">hmacBaseAddress</td><td>Base address of HMAC module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dataLength</td><td>Length of the block in bytes. Note: The value must be a multiple of 64 if the close hash is not set in the mode register.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Not</td><td>applicable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="gaf2333bc6fe289e21a0c2ea29f1e07b25"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HMAC_setHMACKey </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *&#160;</td>
          <td class="paramname"><em>hmacBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>ptrKey</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 This function writes HMAC key to the inner or outer digest registers.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">hmacBaseAddress</td><td>Base address of HMAC module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ptrKey</td><td>Pointer to the key. Note: Key MUST be 64 bytes long.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Not</td><td>applicable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga55c317213fd84152e3a2b8f5d6bc4e5c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HMAC_setHMACPPKey </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *&#160;</td>
          <td class="paramname"><em>hmacBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>ptrKey</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 This function writes a pre-processed HMAC key to the inner or outer digest registers.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">hmacBaseAddress</td><td>Base address of HMAC module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ptrKey</td><td>Pointer to the key. Note: Key MUST be 64 bytes long.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Not</td><td>applicable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga041725b050d79988ecf9b8ddb568f38d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HMAC_writeData </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *&#160;</td>
          <td class="paramname"><em>hmacBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>ptrData</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 This function writes 16 words of data into the data register. If the data registers are not ready, the function will block the caller.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">hmacBaseAddress</td><td>Base address of HMAC module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ptrData</td><td>Pointer to the data buffer.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Not</td><td>applicable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga0782e35e1567eb466f3973a628796e9d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HMAC_writeDigestCount </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *&#160;</td>
          <td class="paramname"><em>hmacBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>digestCount</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 This function writes the byte count of the current hashing operation.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">hmacBaseAddress</td><td>Base address of HMAC module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">digestCount</td><td>Number of bytes to write.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Not</td><td>applicable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="gaa073fbb371abcaac9ee0f1221e0cc2df"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HMAC_writeResult </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="reg__sha_8h.html#a52e9b07b37cda52bd1b55c802dd71ecd">SHARegs</a> *&#160;</td>
          <td class="paramname"><em>hmacBaseAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>ptrData</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 This function writes the result of a hash operation.The length of hash or digest depends on the algorithm used for hashing.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">hmacBaseAddress</td><td>Base address of HMAC module memory mapped registers. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">ptrData</td><td>Pointer to a data buffer where the data is stored.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Not</td><td>applicable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
<hr size="1"><small>
Copyright  2018, Texas Instruments Incorporated</small>
</body>
</html>
